﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using Photon.Pun;

public class ItemScript : MonoBehaviourPunCallbacks {

	[HideInInspector]
	public GameObject myOwner;
	[HideInInspector]
	public Image background;
	[HideInInspector]
	public Vector3 lastPos, itemRot;
	[HideInInspector]
	public bool pickedUp = false, isActive = false;
	[HideInInspector]
	public Rigidbody rBody;

	// Use this for initialization
	public void Start () {
		lastPos = transform.position;
		itemRot = new Vector3 (-130f, 0f, 0f);
		rBody = GetComponent<Rigidbody> ();
	}
	
	// Update is called once per frame
	public void Update () {
		if (!pickedUp)
			AvailableItem ();
	}

	void AvailableItem () {

		// give the wand artificial gravity
		Ray ray = new Ray (transform.position, Vector3.down);
		RaycastHit hit;
		if (Physics.Raycast (ray, out hit)) {
			if (hit.distance > 1f)
				rBody.AddForce (0f, -12f, 0f);
			else
				rBody.velocity = Vector3.zero;
		}

		Debug.DrawRay (transform.position, Vector3.down, Color.red);

		// display the wand on the ground so it looks like it's something to be picked up
		transform.localScale = new Vector3 (2.25f, 2.25f, 2.25f);
		itemRot += new Vector3 (0f, 45f * Time.deltaTime, 0f);
		transform.localEulerAngles = itemRot;
	}

    [PunRPC]
    public void DropItem(int ownerID, int wandID, float forceMagnitude, Vector3 direction) {
        if (photonView.ViewID != wandID) {
            return;
        }
        GameObject[] players = GameObject.FindGameObjectsWithTag("Player");
        foreach (GameObject player in players) {
            if (player.GetComponent<PlayerBase>().photonView.Owner.ActorNumber == ownerID) {
                player.GetComponent<PlayerBase>().DropItem(gameObject, forceMagnitude, direction);
            }
        }
    }
}
